/**
 * 远程web服务器调用接口
 */
//开放对象ytb
var ytb = {};
/*
 * 打开新窗口
 * 简单调用：
 * ytb.openWebContainer({
 *   pageParam:{
 *       url:'/apph5/agreement',//完整的url去掉域名（如：http://mobiledev.yantubao.com）和版本号（如：v3）,会根据具体情况自动切换正式环境和测试环境
 *                              //也可以传入完整的网址，但是要包含http://(如：http://mobiledev.yantubao.com/app/page)，需要手动切换正式环境和测试环境
 *       rightBar:{  //右侧按钮
 *           css:{
 *               color:'#ff0'
 *           },
 *           text:'eee',
 *           action:'funcGoto();'
 *       },
 *       header:'aaa'
 *   }
 * });
 * 其他具体需要的各种参数可以在apicloud官网中查找openWin方法
 * pageParam对象：
 *       url:目标地址
 *       header：显示的标题
 *       rightBar:右侧按钮事件
 *           css:样式
 *           text：文字或者html元素
 *           action：需要执行的动作，需要在页面上写好
 *
 *
 * */
ytb.openWebContainer = function (option) {
    var url = option.pageParam.url;
    var str = 'SID=' + api.deviceId;
    if (url.indexOf('?') > -1) {
        option.pageParam.url += '&' + str;
    } else {
        option.pageParam.url += '?' + str;
    }
    api.openWin({
        name: option.winName || 'webContainer' + new Date().getTime(),
        url: 'widget://html/webContainer/container.html',
        pageParam: option.pageParam,
        bounces: option.bounces,
        bgColor: option.bgColor,
        scrollToTop: option.scrollToTop,
        vScrollBarEnabled: option.vScrollBarEnabled,
        hScrollBarEnabled: option.hScrollBarEnabled,
        scaleEnabled: option.scaleEnabled,
        slidBackEnabled: option.slidBackEnabled,
        animation: option.animation,
        showProgress: option.showProgress,
        delay: option.delay,
        reload: option.reload,
        allowEdit: option.allowEdit,
        softInputMode: option.softInputMode
    });
};
/*
 * 预览多张图片
 * 简单调用：
 *  ytb.imageBrowser({
 *       imageSrcArray: [
 *       'http://mobiledev.yantubao.com//uploads/banner5.jpg?r=33',
 *       'http://mobiledev.yantubao.com//uploads/banner1.jpg?r=11',
 *       'http://mobiledev.yantubao.com//uploads/banner2.jpg?r=52'
 *       ],//要预览的图片数组
 *       activeIndex:2//默认显示第几张图片，不传默认显示第一张
 * });
 * */
ytb.imageBrowser = function (option) {
    if (option.imageSrcArray.length == 0) {
        alert('请传入图片地址数组');
        return;
    }
    api.require('imageBrowser').openImages({
        imageUrls: option.imageSrcArray,
        showList: false,
        activeIndex: option.activeIndex || 0
    });
};
/*
 * 分享接口
 * 简单调用：
 *   ytb.openShareFrame({
 *       pageParam:{
 *           title:'标题',//标题
 *           description:'描述',//描述
 *           content:'内容',//内容
 *           imgUrl:'http://mobiledev.yantubao.com/asd.jpg',//图片地址
 *           url:'http://mobiledev.yantuabo.com/app/page'，//网页地址
 *           sms:'短信内容'//短信分享内容
 *       }
 *   });
 * */
ytb.openShareFrame = function (option) {
    api.openFrame({
        name: 'shareFrame',
        url: 'widget://html/modules/share.html',
        pageParam: option.pageParam,
        rect: {
            x: 0,
            y: 0,
            h: 'auto',
            w: 'auto'
        },
        bgColor: 'rgba(0,0,0,0)'
    });
};
/*
 * 聊天接口
 * 简单调用：
 *       ytb.chat({
 *           targetId:'12312312312',//id
 *           targetName:'研途君',//名字
 *           targetAvatar:'http://www.yantubao.com/ss/aa.jpg',//头像地址
 *       });
 * */
ytb.chat = function (options) {
    api.openWin({
        name: 'messageDetail',
        url: 'widget://html/message/detail.html',
        pageParam: {
            targetId: options.targetId,
            targetName: options.targetName,
            targetAvatar: options.targetAvatar,
            targetType: 'PRIVATE'//PRIVATE or GROUP
        }
    });
};

/*
* 跳转个人主页接口
* 简单调用：
*       ytb.homePage({
*           tragetId:'112356',//id
*       });
* */
ytb.homePage=function(options){
    api.openWin({
        name: 'PersonHome',
        url:'widget://html/personHomePage/homeContainer.html',
        pageParam:{
            memberID: options.memberID
        }
    });
};
/*
* 选择省份，学校，学院，专业
* 1.简单调用：
*   ytb.selectPSCS({
*       selectType:false,//false,不选择科目，直接选择地区，true可以选择科目
*       selectLength：4//4表示4个都选，参数是多少就选择多少层，如参数为2：只选择省份和大学，不传默认为4
*   });
* 2.在页面上添加一个事件监听，用于获取该模块的返回值
*   api.addEventListener({
*       name: 'selectSpecialEnd'
*   }, function (ret, err) {
*       var spanObj = $('#header span.p-type');
*       spanObj.removeClass('p-off');
*       if (ret.value.status && ret.value.comeFrom == 'selectPSCS') {
*           //监听到页面选择返回的数据，进行相关处理
*       }
*   });
* */
ytb.selectPSCS = function(options){
    api.openFrame({
        name: 'selectPSCS',
        url: 'widget://html/modules/selectSpecialID.html',
        bgColor: 'rgba(0,0,0,0)',
        pageParam: {
            comeFrom: 'selectPSCS',
            selectType:options.selectType,
            selectLength:options.selectLength
        }
    });
};
/*
* 联系客服
* 简单调用(史上最简单的)：ytb.connectMeChat();
* */
ytb.connectMeChat = function(){
    api.execScript({
        name: api.winName,
        script: 'webConenectMeChat();'
    });
};