/**
 * Created by chenyikun on 2015/12/1.
 */
var selectSchoolData;//选择的学校数据
var pageID;//分页ID
var loadMore;//是否加载更多
var listData;//列表数据
var listRactive;//ractive对象
var isFirstLoad;//是否是第一次加载
//给初始数据赋值
var pageInit = function action(){
	pageID = 1;
	loadMore = false;
	isFirstLoad = true;
	listData = [];
	selectSchoolData = $api.getStorage(conf.localData.senior.selectSchool);
	if (selectSchoolData == undefined) {
		selectSchoolData = {
			province: { id: '', name: '省份' },
			university: { id: '', name: '学校' },
			college: { id: '', name: '学院' },
			speciality: { id: '', name: '专业' }
		};
		$api.setStorage(conf.localData.senior.selectSchool);
	}
};
//对象加载完毕
apiready = function (){
	pageInit();//页面初始化
	listRactiveinit();//ractive对象初始化
	getSeniorsList();//获取学长列表
	//设置下拉刷新
	api.setRefreshHeaderInfo({
		visible: true,
		bgColor: '#f8f8f8',
		textColor: '#666',
		textDown: '下拉刷新...',
		textUp: '松开刷新...',
		showTime: true
	}, pullRefresh);
	//设置上拉加载更多
	api.addEventListener({
		name: 'scrolltobottom',
		extra: { threshold: 100 }
	}, function (){
		if (loadMore) {
			loadMore = false;
			getSeniorsList();
		}
	});
};
//ractive对象初始化
function listRactiveinit(){
	listRactive = new Ractive({
		el: '#listContainer',
		template: '#listTemplate',
		data: {
			listData: listData,
			formatBeGoodAt: function (arr){
				if (arr.length == 0 || !arr) {
					return '未填写';
				}
				var str = '';
				var max = arr.length - 1;
				arr.map(function (item, index){
					str += item.sName;
					if (index < max) {
						str += ' / ';
					}
				});
				return str;
			},
			formateCommonGuide: function (str){
				var obj = {};
				str = str || '免费';
				if (str == '免费') {
					obj.status = 'free';
					obj.str = str;
				} else {
					obj.status = 'nofree';
					obj.str = '¥' + parseFloat(str);
				}
				return obj;
			},
			decodeURI: function (str){
				return decodeURI(str);
			}
		}
	});
}
//获取学长列表
function getSeniorsList(callback){
	dc.senior.list({
		SpecialityID: selectSchoolData.speciality.id,
		PageID: pageID,
		sUniversity: selectSchoolData.university.name,
		sCollege: selectSchoolData.college.name
	}, function (ret){
		if (ret.status.code == 1) {
			//填充数据
			var data = ret.info.senior;
			listData = $.merge(listData, data);
			//更新列表数据
			listRactive.update('listData');
			//判断是否还有更多数据
			if (data.length < conf.ajaxOnePageMax) {//没有更多数据
				loadMoreAction(false);
				if (listData.length < conf.ajaxOnePageMax) {//只有第一页

				}
			} else {//还有数据，继续分页
				pageID++;
				loadMoreAction(true);
			}
		}
		//下拉刷新完成调用
		api.refreshHeaderLoadDone();
		//若有回调函数则执行
		try {
			callback();
		} catch (e) {
		}
	});
}
//是否继续加载
function loadMoreAction(type){
	//列表没有数据
	if (listData.length == 0) {
		$('.list-nodata').show();
	} else {
		$('.list-nodata').hide();
	}
	if (type == false) {//没有更多数据
		loadMore = false;
		$('#loadingMore').hide();
	} else {//还有数据，显示加载动画
		loadMore = true;
		$('#loadingMore').show();
	}
}
//下拉刷新
function pullRefresh(){
	//重置初始数据
	pageInit();
	getSeniorsList(listRactiveinit);
}
//进入学长主页
function goToDetail(index){
	var data = listData[index];
	if (index == 0 && data.ID == undefined) {//研途君
		com.connectMeChat('35349');
	} else {//进入学长主页
		gtl.senior.detail(data);
	}
}
var seniorData;
var secondsForADay = 24 * 60 * 60;//一天的秒数
//咨询
function zixun(index){
	seniorData = listData[index];
	if (seniorData.fCommonGuide == '免费') {//免费咨询，直接聊天
		if(seniorData.ID == undefined){
			com.connectMeChat();
			return false;
		}
		com.chatToSomeone({
			targetId: seniorData.ID,
			targetName: seniorData.sNickName,
			targetAvatar: seniorData.sAvatar,
			targetType: 'PRIVATE'//PRIVATE or GROUP,SYSTEM
		});
		return false;
	}
	if (com.userInfo.member.ID == seniorData.ID) {//不能自己咨询自己
		api.toast({ msg: '不能咨询您自己哦~', duration: 2000, location: 'middle' });
		return false;
	}
	//付费咨询，获取开始时间
	var dGuideStart = seniorData.dGuideStart;
	if (dGuideStart != '' && seniorData.bClose != 1) {//已经购买过咨询，直接进入咨询页面
		var remain = parseInt(new Date().getTime() / 1000) - parseInt(dGuideStart);
		if (remain < secondsForADay) {//已经购买并且还未过期
			gtl.senior.zixun({
				header: seniorData.sUniversity + ' ' + seniorData.sNickName,
				GuideID: seniorData.GuideID
			});
			return;
		}
	}
	api.openFrame({
		name: 'tuwenZixun',
		url: 'ruwenBuy.html',
		rect: {
			x: 0,
			y: 0,
			w: 'auto',
			h: 'auto'
		},
		pageParam: seniorData,
		bounces: false,
		bgColor:'rgba(0,0,0,0)'
	});
}
//立即购买
function buy(){
	$('#backdrop').hide();
	if (seniorData.fCommonGuide != '免费') {
		gtl.senior.buy(api.pageParam);
	} else {
		com.chatToSomeone({
			targetId: api.pageParam.ID,
			targetName: seniorData.sNickName,
			targetAvatar: seniorData.sAvatar,
			targetType: 'PRIVATE'//PRIVATE or GROUP,SYSTEM
		});
	}
}